/**
 * Copyright (c) 2011-2020, hubin (jobob@qq.com).
 * <p>
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * <p>
 * http://www.apache.org/licenses/LICENSE-2.0
 * <p>
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.baomidou.mybatisplus.generator;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.generator.config.FileOutConfig;
import com.baomidou.mybatisplus.generator.config.builder.ConfigBuilder;

/**
 * <p>
 * 抽象的对外接口
 * </p>
 *
 * @author hubin
 * @since 2016-12-07
 */
public abstract class InjectionConfig {

	/**
	 * 全局配置
	 */
	private ConfigBuilder config;

	/**
	 * 自定义返回配置 Map 对象
	 */
	private Map<String, Object> map;

	/**
	 * 自定义输出文件
	 */
	private List<FileOutConfig> fileOutConfigList;

	/**
	 * 注入自定义 Map 对象
	 */
	public abstract void initMap();

	public ConfigBuilder getConfig() {
		return config;
	}

	public void setConfig(ConfigBuilder config) {
		this.config = config;
	}

	public Map<String, Object> getMap() {
		return map;
	}

	public void setMap(Map<String, Object> map) {
		this.map = map;
	}

	public List<FileOutConfig> getFileOutConfigList() {
		return fileOutConfigList;
	}

	public void setFileOutConfigList(List<FileOutConfig> fileOutConfigList) {
		this.fileOutConfigList = fileOutConfigList;
	}

}
